aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorKhem Raj <raj.khem@gmail.com>2010-12-08 19:04:45 -0800
committerThomas Zimmermann <zimmermann@vdm-design.de>2011-09-10 15:48:46 +0200
commitf3830e4f86e0bad78bc9bebbed5b1fb1eea6c3f7 (patch)
treee327e089bbcae590795b15f201386b83a608cefd
parent78ab4d045fb020eeec0400b5a02ece99c642f560 (diff)
downloadopenembedded-f3830e4f86e0bad78bc9bebbed5b1fb1eea6c3f7.zip
openembedded-f3830e4f86e0bad78bc9bebbed5b1fb1eea6c3f7.tar.gz
openembedded-f3830e4f86e0bad78bc9bebbed5b1fb1eea6c3f7.tar.bz2
binutils-2.21: Add recipes for binutils 2.21 release
Signed-off-by: Khem Raj <raj.khem@gmail.com>
-rw-r--r--recipes/binutils/binutils-2.21/110-arm-eabi-conf.patch22
-rw-r--r--recipes/binutils/binutils-2.21/binutils-2.16.1-e300c2c3.patch19
-rw-r--r--recipes/binutils/binutils-2.21/binutils-2.16.91.0.6-objcopy-rename-errorcode.patch39
-rw-r--r--recipes/binutils/binutils-2.21/binutils-arm-pr7093.patch19
-rw-r--r--recipes/binutils/binutils-2.21/binutils-uclibc-100-uclibc-conf.patch34
-rw-r--r--recipes/binutils/binutils-2.21/binutils-uclibc-300-001_ld_makefile_patch.patch50
-rw-r--r--recipes/binutils/binutils-2.21/binutils-uclibc-300-006_better_file_error.patch43
-rw-r--r--recipes/binutils/binutils-2.21/binutils-uclibc-300-012_check_ldrunpath_length.patch48
-rw-r--r--recipes/binutils/binutils-2.21/binutils-uclibc-gas-needs-libm.patch38
-rw-r--r--recipes/binutils/binutils-2.21/fix-clone-conflicts.patch72
-rw-r--r--recipes/binutils/binutils-cross-sdk_2.21.bb2
-rw-r--r--recipes/binutils/binutils-cross_2.21.bb2
-rw-r--r--recipes/binutils/binutils_2.21.bb15
13 files changed, 403 insertions, 0 deletions
diff --git a/recipes/binutils/binutils-2.21/110-arm-eabi-conf.patch b/recipes/binutils/binutils-2.21/110-arm-eabi-conf.patch
new file mode 100644
index 0000000..2623301
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/110-arm-eabi-conf.patch
@@ -0,0 +1,22 @@
+--- /tmp/configure.ac 2008-06-22 14:14:59.000000000 +0200
++++ binutils-2.18.50.0.7/configure.ac 2008-06-22 14:15:30.000000000 +0200
+@@ -561,7 +561,7 @@
+ noconfigdirs="$noconfigdirs target-libffi target-qthreads"
+ libgloss_dir=arm
+ ;;
+- arm*-*-linux-gnueabi)
++ arm*-*-linux-gnueabi | arm*-*-linux-uclibcgnueabi)
+ noconfigdirs="$noconfigdirs target-qthreads"
+ noconfigdirs="$noconfigdirs target-libobjc"
+ case ${with_newlib} in
+--- /tmp/configure 2008-06-22 14:17:11.000000000 +0200
++++ binutils-2.18.50.0.7/configure 2008-06-22 14:17:56.000000000 +0200
+@@ -2307,7 +2307,7 @@
+ noconfigdirs="$noconfigdirs target-libffi target-qthreads"
+ libgloss_dir=arm
+ ;;
+- arm*-*-linux-gnueabi)
++ arm*-*-linux-gnueabi | arm*-*-linux-uclibcgnueabi)
+ noconfigdirs="$noconfigdirs target-qthreads"
+ noconfigdirs="$noconfigdirs target-libobjc"
+ case ${with_newlib} in
diff --git a/recipes/binutils/binutils-2.21/binutils-2.16.1-e300c2c3.patch b/recipes/binutils/binutils-2.21/binutils-2.16.1-e300c2c3.patch
new file mode 100644
index 0000000..c5e4234
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-2.16.1-e300c2c3.patch
@@ -0,0 +1,19 @@
+Adds support for Freescale Power architecture e300c2 and e300c3 cores.
+http://www.bitshrine.org/gpp/tc-fsl-x86lnx-e300c3-nptl-4.0.2-2.src.rpm
+
+Leon Woestenberg <leonw@mailcan.com>
+
+diff -uNr binutils-2.16.1.orig/gas/config/tc-ppc.c binutils-2.16.1/gas/config/tc-ppc.c
+--- binutils-2.16.1.orig/gas/config/tc-ppc.c 2005-03-02 13:24:01.000000000 +0000
++++ binutils-2.16.1/gas/config/tc-ppc.c 2006-07-04 11:45:24.000000000 +0100
+@@ -879,6 +879,10 @@
+ else
+ ppc_cpu |= PPC_OPCODE_SPE;
+ }
++ else if (strcmp (arg, "pmr") == 0)
++ {
++ ppc_cpu |= PPC_OPCODE_PMR;
++ }
+ /* -mppc64 and -m620 mean to assemble for the 64-bit PowerPC
+ 620. */
+ else if (strcmp (arg, "ppc64") == 0 || strcmp (arg, "620") == 0)
diff --git a/recipes/binutils/binutils-2.21/binutils-2.16.91.0.6-objcopy-rename-errorcode.patch b/recipes/binutils/binutils-2.21/binutils-2.16.91.0.6-objcopy-rename-errorcode.patch
new file mode 100644
index 0000000..8df5b1f
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-2.16.91.0.6-objcopy-rename-errorcode.patch
@@ -0,0 +1,39 @@
+# strip (and objcopy) fail to set the error code if there is no
+# output file name and the rename of the stripped (or copied) file
+# fails, yet the command fails to do anything. This fixes both
+# objcopy and strip.
+#
+# modification by bero: Ported to 2.16.91.0.6
+#
+#Signed-off-by: John Bowler <jbowler@acm.org>
+#Signed-off-by: Bernhard Rosenkraenzer <bero@arklinux.org>
+---
+# binutils/objcopy.c | 8 +++++---
+# 1 file changed, 5 insertions(+), 3 deletions(-)
+#
+Index: src/binutils/objcopy.c
+===================================================================
+--- src.orig/binutils/objcopy.c 2007-08-09 13:26:03.000000000 +0100
++++ src/binutils/objcopy.c 2007-08-09 16:36:12.000000000 +0100
+@@ -2787,8 +2787,9 @@ strip_main (int argc, char *argv[])
+ if (preserve_dates)
+ set_times (tmpname, &statbuf);
+ if (output_file != tmpname)
+- smart_rename (tmpname, output_file ? output_file : argv[i],
+- preserve_dates);
++ if (smart_rename (tmpname, output_file ? output_file : argv[i],
++ preserve_dates))
++ hold_status = 1;
+ status = hold_status;
+ }
+ else
+@@ -3411,7 +3412,8 @@ copy_main (int argc, char *argv[])
+ if (preserve_dates)
+ set_times (tmpname, &statbuf);
+ if (tmpname != output_filename)
+- smart_rename (tmpname, input_filename, preserve_dates);
++ if (smart_rename (tmpname, input_filename, preserve_dates))
++ status = 1;
+ }
+ else
+ unlink_if_ordinary (tmpname);
diff --git a/recipes/binutils/binutils-2.21/binutils-arm-pr7093.patch b/recipes/binutils/binutils-2.21/binutils-arm-pr7093.patch
new file mode 100644
index 0000000..ad4a556
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-arm-pr7093.patch
@@ -0,0 +1,19 @@
+Index: binutils/bfd/elf32-arm.c
+===================================================================
+RCS file: /cvs/src/src/bfd/elf32-arm.c,v
+retrieving revision 1.162
+retrieving revision 1.163
+diff -u -r1.162 -r1.163
+--- binutils/bfd/elf32-arm.c 23 Dec 2008 09:01:45 -0000 1.162
++++ binutils/bfd/elf32-arm.c 23 Dec 2008 11:46:17 -0000 1.163
+@@ -4608,6 +4608,10 @@
+ Elf_Internal_Shdr *hdr;
+ unsigned int i, localsyms;
+
++ /* PR 7093: Make sure that we are dealing with an arm elf binary. */
++ if (! is_arm_elf (abfd))
++ return;
++
+ if ((abfd->flags & DYNAMIC) != 0)
+ return;
+
diff --git a/recipes/binutils/binutils-2.21/binutils-uclibc-100-uclibc-conf.patch b/recipes/binutils/binutils-2.21/binutils-uclibc-100-uclibc-conf.patch
new file mode 100644
index 0000000..8de04e0
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-uclibc-100-uclibc-conf.patch
@@ -0,0 +1,34 @@
+--- binutils-2.18.orig/configure
++++ binutils-2.18/configure
+@@ -2206,7 +2206,7 @@
+ am33_2.0-*-linux*)
+ noconfigdirs="$noconfigdirs ${libgcj} target-newlib target-libgloss"
+ ;;
+- sh-*-linux*)
++ sh*-*-linux*)
+ noconfigdirs="$noconfigdirs ${libgcj} target-newlib target-libgloss"
+ ;;
+ sh*-*-pe|mips*-*-pe|*arm-wince-pe)
+@@ -2504,7 +2504,7 @@
+ romp-*-*)
+ noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss ${libgcj}"
+ ;;
+- sh-*-* | sh64-*-*)
++ sh*-*-* | sh64-*-*)
+ case "${host}" in
+ i[3456789]86-*-vsta) ;; # don't add gprof back in
+ i[3456789]86-*-go32*) ;; # don't add gprof back in
+--- binutils-2.18.orig/gprof/configure
++++ binutils-2.18/gprof/configure
+@@ -4124,6 +4124,11 @@
+ lt_cv_deplibs_check_method=pass_all
+ ;;
+
++linux-uclibc*)
++ lt_cv_deplibs_check_method=pass_all
++ lt_cv_file_magic_test_file=`echo /lib/libuClibc-*.so`
++ ;;
++
+ netbsd*)
+ if echo __ELF__ | $CC -E - | $GREP __ELF__ > /dev/null; then
+ lt_cv_deplibs_check_method='match_pattern /lib[^/]+(\.so\.[0-9]+\.[0-9]+|_pic\.a)$'
diff --git a/recipes/binutils/binutils-2.21/binutils-uclibc-300-001_ld_makefile_patch.patch b/recipes/binutils/binutils-2.21/binutils-uclibc-300-001_ld_makefile_patch.patch
new file mode 100644
index 0000000..04a7e61
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-uclibc-300-001_ld_makefile_patch.patch
@@ -0,0 +1,50 @@
+#!/bin/sh -e
+## 001_ld_makefile_patch.dpatch
+##
+## All lines beginning with `## DP:' are a description of the patch.
+## DP: Description: correct where ld scripts are installed
+## DP: Author: Chris Chimelis <chris@debian.org>
+## DP: Upstream status: N/A
+## DP: Date: ??
+
+if [ $# -ne 1 ]; then
+ echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
+ exit 1
+fi
+
+[ -f debian/patches/00patch-opts ] && . debian/patches/00patch-opts
+patch_opts="${patch_opts:--f --no-backup-if-mismatch}"
+
+case "$1" in
+ -patch) patch $patch_opts -p1 < $0;;
+ -unpatch) patch $patch_opts -p1 -R < $0;;
+ *)
+ echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
+ exit 1;;
+esac
+
+exit 0
+
+@DPATCH@
+--- binutils-2.16.91.0.1/ld/Makefile.am
++++ binutils-2.16.91.0.1/ld/Makefile.am
+@@ -20,7 +20,7 @@
+ # We put the scripts in the directory $(scriptdir)/ldscripts.
+ # We can't put the scripts in $(datadir) because the SEARCH_DIR
+ # directives need to be different for native and cross linkers.
+-scriptdir = $(tooldir)/lib
++scriptdir = $(libdir)
+
+ EMUL = @EMUL@
+ EMULATION_OFILES = @EMULATION_OFILES@
+--- binutils-2.16.91.0.1/ld/Makefile.in
++++ binutils-2.16.91.0.1/ld/Makefile.in
+@@ -268,7 +268,7 @@
+ # We put the scripts in the directory $(scriptdir)/ldscripts.
+ # We can't put the scripts in $(datadir) because the SEARCH_DIR
+ # directives need to be different for native and cross linkers.
+-scriptdir = $(tooldir)/lib
++scriptdir = $(libdir)
+ BASEDIR = $(srcdir)/..
+ BFDDIR = $(BASEDIR)/bfd
+ INCDIR = $(BASEDIR)/include
diff --git a/recipes/binutils/binutils-2.21/binutils-uclibc-300-006_better_file_error.patch b/recipes/binutils/binutils-2.21/binutils-uclibc-300-006_better_file_error.patch
new file mode 100644
index 0000000..f337611
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-uclibc-300-006_better_file_error.patch
@@ -0,0 +1,43 @@
+#!/bin/sh -e
+## 006_better_file_error.dpatch by David Kimdon <dwhedon@gordian.com>
+##
+## All lines beginning with `## DP:' are a description of the patch.
+## DP: Specify which filename is causing an error if the filename is a
+## DP: directory. (#45832)
+
+if [ $# -ne 1 ]; then
+ echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
+ exit 1
+fi
+
+[ -f debian/patches/00patch-opts ] && . debian/patches/00patch-opts
+patch_opts="${patch_opts:--f --no-backup-if-mismatch}"
+
+case "$1" in
+ -patch) patch $patch_opts -p1 < $0;;
+ -unpatch) patch $patch_opts -p1 -R < $0;;
+ *)
+ echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
+ exit 1;;
+esac
+
+exit 0
+
+@DPATCH@
+diff -urNad /home/james/debian/packages/binutils/binutils-2.14.90.0.6/bfd/opncls.c binutils-2.14.90.0.6/bfd/opncls.c
+--- /home/james/debian/packages/binutils/binutils-2.14.90.0.6/bfd/opncls.c 2003-07-23 16:08:09.000000000 +0100
++++ binutils-2.14.90.0.6/bfd/opncls.c 2003-09-10 22:35:00.000000000 +0100
+@@ -150,6 +150,13 @@
+ {
+ bfd *nbfd;
+ const bfd_target *target_vec;
++ struct stat s;
++
++ if (stat (filename, &s) == 0)
++ if (S_ISDIR(s.st_mode)) {
++ bfd_set_error (bfd_error_file_not_recognized);
++ return NULL;
++ }
+
+ nbfd = _bfd_new_bfd ();
+ if (nbfd == NULL)
diff --git a/recipes/binutils/binutils-2.21/binutils-uclibc-300-012_check_ldrunpath_length.patch b/recipes/binutils/binutils-2.21/binutils-uclibc-300-012_check_ldrunpath_length.patch
new file mode 100644
index 0000000..b6f5a25
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-uclibc-300-012_check_ldrunpath_length.patch
@@ -0,0 +1,48 @@
+#!/bin/sh -e
+## 012_check_ldrunpath_length.dpatch by Chris Chimelis <chris@debian.org>
+##
+## All lines beginning with `## DP:' are a description of the patch.
+## DP: Only generate an RPATH entry if LD_RUN_PATH is not empty, for
+## DP: cases where -rpath isn't specified. (#151024)
+
+if [ $# -ne 1 ]; then
+ echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
+ exit 1
+fi
+
+[ -f debian/patches/00patch-opts ] && . debian/patches/00patch-opts
+patch_opts="${patch_opts:--f --no-backup-if-mismatch}"
+
+case "$1" in
+ -patch) patch $patch_opts -p1 < $0;;
+ -unpatch) patch $patch_opts -p1 -R < $0;;
+ *)
+ echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
+ exit 1;;
+esac
+
+exit 0
+
+@DPATCH@
+Index: src/ld/emultempl/elf32.em
+===================================================================
+--- src.orig/ld/emultempl/elf32.em 2009-09-23 06:54:28.000000000 -0700
++++ src/ld/emultempl/elf32.em 2009-10-06 10:58:16.883414592 -0700
+@@ -1237,6 +1237,8 @@ fragment <<EOF
+ && command_line.rpath == NULL)
+ {
+ lib_path = (const char *) getenv ("LD_RUN_PATH");
++ if ((lib_path) && (strlen (lib_path) == 0))
++ lib_path = NULL;
+ if (gld${EMULATION_NAME}_search_needed (lib_path, &n,
+ force))
+ break;
+@@ -1463,6 +1465,8 @@ gld${EMULATION_NAME}_before_allocation (
+ rpath = command_line.rpath;
+ if (rpath == NULL)
+ rpath = (const char *) getenv ("LD_RUN_PATH");
++ if ((rpath) && (strlen (rpath) == 0))
++ rpath = NULL;
+
+ for (abfd = link_info.input_bfds; abfd; abfd = abfd->link_next)
+ {
diff --git a/recipes/binutils/binutils-2.21/binutils-uclibc-gas-needs-libm.patch b/recipes/binutils/binutils-2.21/binutils-uclibc-gas-needs-libm.patch
new file mode 100644
index 0000000..db838cf
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/binutils-uclibc-gas-needs-libm.patch
@@ -0,0 +1,38 @@
+Source: Khem Raj <raj.khem@gmail.com>
+Disposition: submit upstream.
+
+Description:
+
+We do not need to have the libtool patch anymore for binutils after
+libtool has been updated upstream it include support for it. However
+for building gas natively on uclibc systems we have to link it with
+-lm so that it picks up missing symbols.
+
+/local/build_area/BUILD/arm_v5t_le_uclibc/binutils-2.17.50/objdir/libiberty/pic/libiberty.a(floatformat.o): In function `floatformat_from_double':
+floatformat.c:(.text+0x1ec): undefined reference to `frexp'
+floatformat.c:(.text+0x2f8): undefined reference to `ldexp'
+/local/build_area/BUILD/arm_v5t_le_uclibc/binutils-2.17.50/objdir/libiberty/pic/libiberty.a(floatformat.o): In function `floatformat_to_double':
+floatformat.c:(.text+0x38a): undefined reference to `ldexp'
+floatformat.c:(.text+0x3d2): undefined reference to `ldexp'
+floatformat.c:(.text+0x43e): undefined reference to `ldexp' floatformat.c:(.text+0x4e2): undefined reference to `ldexp'
+collect2: ld returned 1 exit status
+make[4]: *** [as-new] Error 1
+
+Index: binutils-2.17.50/gas/configure.tgt
+===================================================================
+--- binutils-2.17.50.orig/gas/configure.tgt
++++ binutils-2.17.50/gas/configure.tgt
+@@ -408,6 +408,12 @@ case ${generic_target} in
+ *-*-netware) fmt=elf em=netware ;;
+ esac
+
++case ${generic_target} in
++ arm-*-*uclibc*)
++ need_libm=yes
++ ;;
++esac
++
+ case ${cpu_type} in
+ alpha | arm | i386 | ia64 | mips | ns32k | pdp11 | ppc | sparc | z80 | z8k)
+ bfd_gas=yes
+
diff --git a/recipes/binutils/binutils-2.21/fix-clone-conflicts.patch b/recipes/binutils/binutils-2.21/fix-clone-conflicts.patch
new file mode 100644
index 0000000..5491e26
--- /dev/null
+++ b/recipes/binutils/binutils-2.21/fix-clone-conflicts.patch
@@ -0,0 +1,72 @@
+Fixes the following error for SH4 native binutils
+
+/scratch/oe/work/sh4-oe-linux-uclibc/binutils-git-r13.2+gitr0+6ef128735ce52ee2acf8cfd80f6d72003dd39ab7/git/gas/config/obj-elf.c:744: error: declaration of 'clone' shadows a global declaration/scratch/oe/sysroots/sh4-oe-linux-uclibc/usr/include/bits/sched.h:74: error: shadowed declaration is here/scratch/oe/work/sh4-oe-linux-uclibc/binutils-git-r13.2+gitr0+6ef128735ce52ee2acf8cfd80f6d72003dd39ab7/git/gas/config/obj-elf.c: In function 'obj_elf_section':/scratch/oe/work/sh4-oe-linux-uclibc/binutils-git-r13.2+gitr0+6ef128735ce52ee2acf8cfd80f6d72003dd39ab7/git/gas/config/obj-elf.c:981: error: declaration of 'clone' shadows a global declaration/scratch/oe/sysroots/sh4-oe-linux-uclibc/usr/include/bits/sched.h:74: error: shadowed declaration is heremake[4]: *** [obj-elf.o] Error 1
+
+-Khem
+
+Index: git/gas/config/obj-elf.c
+===================================================================
+--- git.orig/gas/config/obj-elf.c
++++ git/gas/config/obj-elf.c
+@@ -741,10 +741,10 @@ obj_elf_change_section (const char *name
+ }
+
+ static bfd_vma
+-obj_elf_parse_section_letters (char *str, size_t len, bfd_boolean *clone)
++obj_elf_parse_section_letters (char *str, size_t len, bfd_boolean *duplicate)
+ {
+ bfd_vma attr = 0;
+- *clone = FALSE;
++ *duplicate = FALSE;
+
+ while (len > 0)
+ {
+@@ -775,7 +775,7 @@ obj_elf_parse_section_letters (char *str
+ attr |= SHF_TLS;
+ break;
+ case '?':
+- *clone = TRUE;
++ *duplicate = TRUE;
+ break;
+ /* Compatibility. */
+ case 'm':
+@@ -978,7 +978,7 @@ obj_elf_section (int push)
+
+ if (*input_line_pointer == '"')
+ {
+- bfd_boolean clone;
++ bfd_boolean duplicate;
+
+ beg = demand_copy_C_string (&dummy);
+ if (beg == NULL)
+@@ -986,7 +986,7 @@ obj_elf_section (int push)
+ ignore_rest_of_line ();
+ return;
+ }
+- attr |= obj_elf_parse_section_letters (beg, strlen (beg), &clone);
++ attr |= obj_elf_parse_section_letters (beg, strlen (beg), &duplicate);
+
+ SKIP_WHITESPACE ();
+ if (*input_line_pointer == ',')
+@@ -1038,10 +1038,10 @@ obj_elf_section (int push)
+ attr &= ~SHF_MERGE;
+ }
+
+- if ((attr & SHF_GROUP) != 0 && clone)
++ if ((attr & SHF_GROUP) != 0 && duplicate)
+ {
+ as_warn (_("? section flag ignored with G present"));
+- clone = FALSE;
++ duplicate = FALSE;
+ }
+ if ((attr & SHF_GROUP) != 0 && *input_line_pointer == ',')
+ {
+@@ -1063,7 +1063,7 @@ obj_elf_section (int push)
+ attr &= ~SHF_GROUP;
+ }
+
+- if (clone)
++ if (duplicate)
+ {
+ const char *now_group = elf_group_name (now_seg);
+ if (now_group != NULL)
diff --git a/recipes/binutils/binutils-cross-sdk_2.21.bb b/recipes/binutils/binutils-cross-sdk_2.21.bb
new file mode 100644
index 0000000..876af0b
--- /dev/null
+++ b/recipes/binutils/binutils-cross-sdk_2.21.bb
@@ -0,0 +1,2 @@
+require binutils_git.bb
+require binutils-cross-sdk.inc
diff --git a/recipes/binutils/binutils-cross_2.21.bb b/recipes/binutils/binutils-cross_2.21.bb
new file mode 100644
index 0000000..d47c24d
--- /dev/null
+++ b/recipes/binutils/binutils-cross_2.21.bb
@@ -0,0 +1,2 @@
+require binutils_git.bb
+require binutils-cross.inc
diff --git a/recipes/binutils/binutils_2.21.bb b/recipes/binutils/binutils_2.21.bb
new file mode 100644
index 0000000..12f2eda
--- /dev/null
+++ b/recipes/binutils/binutils_2.21.bb
@@ -0,0 +1,15 @@
+require binutils.inc
+PR = "${INC_PR}.0"
+LICENSE = "GPLv3"
+
+SRC_URI = "${GNU_MIRROR}/binutils/binutils-${PV}.tar.bz2 \
+ file://binutils-uclibc-100-uclibc-conf.patch \
+ file://110-arm-eabi-conf.patch \
+ file://binutils-uclibc-300-001_ld_makefile_patch.patch \
+ file://binutils-uclibc-300-006_better_file_error.patch \
+ file://binutils-uclibc-300-012_check_ldrunpath_length.patch \
+ file://binutils-uclibc-gas-needs-libm.patch \
+ file://fix-clone-conflicts.patch \
+ "
+SRC_URI[md5sum] = "c84c5acc9d266f1a7044b51c85a823f5"
+SRC_URI[sha256sum] = "60abec5bf448eb930a5a15acb8712612377dc8bcfb13dfd5131228f70561d0c7"